#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)2e6+11;
const int inf = int(1e9);
const int mod = (int)1e9 + 9;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, m;
int gr[maxn], f[maxn], pr[maxn];

int g(int x) {
	if(x == 1) return 0;
	if(x % m == 0) return 1 + g(x / m);
	return m - x%m + 1 + g(x / m + 1);
}

int get(int l, int r) {
	int ans = pr[r];
	if(l) ans -= pr[l-1];
	if(ans < 0) ans += mod;
	return ans;
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	/*
	for(m = 2; m <= 4; m++) {
		for(int i = 1; i < maxn; i++)
			gr[i] = g(i);
		for(n = 0; n <= 10; n++) {
			int ans = 0;
			for(int x = 1; x <= 2e6; x++) ans += gr[x]==n;
			printf("dp[%d][%d] = %d;\n", m, n, ans);
		}
	}
	*/

	cin >> m >> n;

	f[0] = f[1] = 1;
	for(int i = 2; i < m; i++) f[i] = (f[i-1] + f[i-1]) % mod;
	f[m] = (f[m-1] + f[m-1] - 1) % mod;

	pr[0] = 1;
	for(int i = 1; i <= m; i++) {
		pr[i] = (pr[i-1] + f[i])  %mod;
	}

	for(int i = m+1; i <= n; i++) {
		f[i] = get(i - m, i-1);
		pr[i] = f[i];
		pr[i] = (pr[i] + pr[i-1]) % mod;
	}

	cout << f[n] << endl;

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
