#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <ctime>
#include <cassert>
#include <utility>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int maxn = (int)2e6;
const int inf = (int)1e9;
const int mod = (int)1e9 + 9;
const double eps = 1e-9;

int m, n, f[maxn], pref[maxn];

int main() {
//	freopen("in", "r", stdin);
//	freopen("out", "w", stdout);

	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	cin >> m >> n;
	f[0] = f[1] = 1;
	for (int i = 2; i < m; ++i)
		f[i] = f[i - 1] * 2 % mod;
	f[m] = (f[m - 1] * 2ll + mod - 1) % mod;

	for (int i = 0; i <= m; ++i) {
		pref[i] = (pref[i] + f[i]) % mod;
		pref[i + 1] = pref[i];
	}

	for (int i = m + 1; i <= n; ++i) {
		f[i] = (pref[i - 1] + mod - pref[i - m - 1]) % mod;
		pref[i] = (pref[i] + f[i]) % mod;
		pref[i + 1] = pref[i];
	}

	cout << f[n];
	return 0;
}                    
