#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "f"

#define mod 1000000009ll
#define M 1000100
#define long long long

long d[M], m, n, sum[M];

long getSum(long r, long l) {
	long ans = sum[r];
	if (l >= 0)
		ans = (ans - sum[l]) % mod;
	return ans;
}

long getD(long n, long k) {
	if (k == 0)
		return d[n];
		
	if (n == 2 && m == 2 && k == m - 1)
		return 0;
	
	n -= (m - k);
	if (n <= 0)
		return 0;
	return d[n];
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	
	cin >> m >> n;
	
	if (n == 0)
	{
		cout << "1\n";
		return 0;
	}
	
	long ans = 0;
	
	d[1] = 1;
	sum[1] = 1;
	
	for (int i = 2; i < 5; ++i)
	{
		for (int j = 0; j < m; ++j)
			d[i] = (d[i] + getD(i - 1, j)) % mod;
		sum[i] = (sum[i - 1] + d[i]) % mod;
	}
	
	for (int i = 5; i < M; ++i)
	{
		d[i] = getSum(i - 1, i - m - 1);
		sum[i] = (sum[i - 1] + d[i]) % mod;
	}
	
	for (int t = 0; t < m; ++t)
		ans = (ans + getD(n, t)) % mod;
	
	if (ans < 0)
		ans += mod;
		
	
	cout << ans << "\n";
	
	
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
