#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int a[55];

int max3(int i, vector<int>& vec){
	int t = min(vec[i], min(vec[i+1], vec[i+2]));
	vec[i] -= t;
	vec[i+1] -= t;
	vec[i+2] -= t;
	return t;
}

int solve(int i , int j, vector<int>& vec){
	if(j - i < 2)
		return 0;
	int ans=0;
	for(; i+2 <= j; i++){
		ans += max3(i, vec);
	}
	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> r(n, 0);
	for(int i = 0; i < n; i++){
		int t;
		cin >> t;
		r[t-1]++;
	}

	int flag = 0, gr, ans = 0;
	for(int i = 0; i < n; i++){
		if(flag){
			if(r[i] == 0){
				ans += solve(gr, i-1, r);
				flag = 0;
			}
		}else{
			if(r[i] != 0){
				gr = i;
				flag = 1;
			}
		}
	}

	if(flag)
		ans += solve(gr, n-1, r);

	cout << ans;
	//cin >> ans;


	//scanf("%d", &t);
}