#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

#define MOD 1000000009

int m;

long long d[1000010];
long long pow2[1000010];

void dp(int n)
{
	if(d[n])
		return;

	//if(n == 0)
		//return;
	if(n >= m)
	{
		dp(n-m);
		if(n - m - 1 > 0)
		{
			dp(n - m - 1);
			d[n] = (d[n - m] - d[n - m - 1] + MOD) % MOD;
		}
		else
		{
			d[n] = d[n - m];
		}
	}

	if(n == 0)
		d[n] = (d[n] + 1) % MOD;
	else
		d[n] = (d[n] + pow2[n-1]) % MOD;

	if(n > m)
		d[n] = (d[n] - pow2[n - m] + MOD) % MOD;
}

int main()
{
	int n;
	pow2[0] = 1;
	cin >> m >> n;
	for(int i = 1; i <= n; i++)
		pow2[i] = (pow2[i-1]*2) % MOD;
	dp(n);
	if(d[n] == 0)
		d[n] = 1;
	cout << d[n] << endl;
	//cin >> n;
}