#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


#define int li

int mod = 1234567891;

int binpow(int q, int w) {
	if (!w)
		return 1;
	if (w & 1)
		return q * binpow(q, w - 1) % mod;
	return binpow(q * q % mod, w / 2);
}

const int C = 100500;

int fact[C];
int revfact[C];

int rev[C];

int getC(int n, int k) {
	if (n < k)
		return 0;
	n %= mod;
	int res = 1;
	for (int i = 1; i <= k; ++i) {
		res = res * (n - i + 1) % mod;
	}
	return res;
}

int getCoef (vector<int>& a) {
	int sum = 0;
	int res = 1;
	for (int i = 0; i < a.size(); ++i) {
		res = res * revfact[a[i]] % mod;
	}
	return res;
}

void solve() {
	fact[0] = 1;
	revfact[0] = 1;
	for (int i = 1; i < C; ++i) {
		fact[i] = fact[i - 1] * i % mod;
		revfact[i] = binpow(fact[i], mod - 2);
		rev[i] = binpow(i, mod - 2);
	}

	int n, m;
	cin >> n >> m;
	vector<int> numbers(m);
	int sum = 0;
	for (int i = 0; i < m; ++i) {
		cin >> numbers[i];
		sum += numbers[i];
	}

	int ans = getC(n * n, sum) * getCoef(numbers) % mod;

	if (n % 2 == 0) {
		vector<int> a(all(numbers));
		bool even = true;
		int cursum = 0;
		for (int i = 0; i < a.size(); ++i) {
			if (a[i] % 2 == 1) {
				even = false;
				break;
			}
			a[i] /= 2;
			cursum += a[i];
		}
		if (even) {
			ans += getC((n * n / 2), cursum) * getCoef(a);
			ans %= mod;
		}
	}
	else {
		for (int j = 0; j <= m; ++j) {
			vector<int> a(all(numbers));
			if (j < m)
				--a[j];
			bool even = true;
			int cursum = 0;
			for (int i = 0; i < a.size(); ++i) {
				if (a[i] % 2 == 1) {
					even = false;
					break;
				}
				a[i] /= 2;
				cursum += a[i];
			}
			if (even) {
				ans += getC((n * n / 2), cursum) * getCoef(a);
				ans %= mod;
			}
		}
	}


	if (n % 2 == 0) {
		vector<int> a(all(numbers));
		bool even = true;
		int cursum = 0;
		for (int i = 0; i < a.size(); ++i) {
			if (a[i] % 4) {
				even = false;
				break;
			}
			a[i] /= 4;
			cursum += a[i];
		}
		if (even) {
			ans += 2 * getC((n * n / 4), cursum) * getCoef(a);
			ans %= mod;
		}
	}
	else {
		for (int j = 0; j <= m; ++j) {
			vector<int> a(all(numbers));
			if (j < m)
				--a[j];
			bool even = true;
			int cursum = 0;
			for (int i = 0; i < a.size(); ++i) {
				if (a[i] % 4) {
					even = false;
					break;
				}
				a[i] /= 4;
				cursum += a[i];
			}
			if (even) {
				ans += 2 * getC((n * n / 4), cursum) * getCoef(a);
				ans %= mod;
			}
		}
	}

	ans *= rev[4];

	ans %= mod;

	cout << (ans + mod) % mod << "\n";

}