#pragma comment(linker , "/STACK:128000000")

#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

void solve();
int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	//cin >> t;
	while(t--) {
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

int dp[51][51][51][51];

const int INF = 1e9;

int dp1[51][51];

void solve() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	sort(all(a));

	vector<int> q(110);
	for (int i = 0; i < n; ++i)
		++q[a[i]];

	memset(dp, 128, sizeof dp);

	dp[0][0][q[1]][q[2]] = 0;

	int pos = 0;

	for (int d = 1; d <= 104; ++d) {
		for (int j = 0; j < q[d]; ++j) {
			for (int k1 = 0; k1 <= q[d - 1]; ++k1)
				for (int k2 = 0; k2 <= q[d]; ++k2)
					for (int k3 = 0; k3 <= q[d + 1]; ++k3) {

						if (dp[pos][k1][k2][k3] < 0)
							continue;

						if (k1 == 0 && k2 == 0 && k3 == 0)
							dp[pos + 1][k1][k2][k3] = max(dp[pos + 1][k1][k2][k3], dp[pos][k1][k2][k3] + 1);

						if (k1 > 0)
							dp[pos + 1][k1 - 1][k2][k3] = max(dp[pos + 1][k1 - 1][k2][k3], dp[pos][k1][k2][k3]);

						if (k2 > 0)
							dp[pos + 1][k1][k2 - 1][k3] = max(dp[pos + 1][k1][k2 - 1][k3], dp[pos][k1][k2][k3]);

						if (k3 > 0)
							dp[pos + 1][k1][k2][k3 - 1] = max(dp[pos + 1][k1][k2][k3 - 1], dp[pos][k1][k2][k3]);
					}
			++pos;
		}

		memset(dp1, 128, sizeof dp1);


		for (int k1 = 0; k1 <= q[d - 1]; ++k1)
			for (int k2 = 0; k2 <= q[d]; ++k2)
				for (int k3 = 0; k3 <= q[d + 1]; ++k3)
					dp1[k2][k3] = max(dp1[k2][k3], dp[pos][k1][k2][k3]);

		for (int k2 = 0; k2 <= q[d]; ++k2)
			for (int k3 = 0; k3 <= q[d + 1]; ++k3)
				for (int k4 = 0; k4 <= 50; ++k4)
					dp[pos][k2][k3][k4] = -INF;

		for (int k2 = 0; k2 <= q[d]; ++k2)
			for (int k3 = 0; k3 <= q[d + 1]; ++k3)
				dp[pos][k2][k3][q[d + 2]] = dp1[k2][k3];
	}

	cout << dp[n][0][0][0] << "\n";

}