#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int N = 51, M = 102;
const int p = 1e9+9;
int q[M];
i64 qHash = 0;
int n;
int a[N];
map<i64, int> used[N];
i64 powers[M];

int uax(int& x, int y)
{
	if (x < y) { x = y; return 1;}
	return 0;
}

void put(int x)
{
	q[x]--;
	qHash -= powers[x];
}

void unput(int x)
{
	q[x]++;
	qHash += powers[x];
}

int f(int p)
{
	//cerr << p << endl;
	//forn (i, n + 1) cerr << q[i] << " "; cerr << endl;
	if (p == n)
	{
		return 0;
	}
	auto it = used[p].find(qHash);
	if (it != used[p].end()) return it->second;	
	int res = 0;
	int val = a[p];
	bool can = false;
	if (q[val - 1])
	{
		can = 1;
		put(val - 1);
		uax(res, f(p + 1));
		unput(val - 1);
	}
	if (q[val + 1])
	{
		can = 1;
		put(val + 1);
		uax(res, f(p + 1));
		unput(val + 1);
	}
	if (!can && q[val])
	{
		can = 1;
		put(val);
		uax(res, f(p + 1));
		unput(val);
	}
	if (!can)
		res = f(p + 1) + 1;
	used[p][qHash] = res;
	return res;
}


void solve()
{
	cin >> n;
	forn (i, n)
	{
		int x;
		cin >> x;
		q[x]++;
		a[i] = x;
		qHash += powers[x];
	}
	cout << f(0) << "\n";
}

int main() {
	powers[0] = 1;
	for1 (i, M - 1) powers[i] = powers[i - 1] * p;

	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	freopen("errput.txt", "w", stderr);
#endif
	solve();
	return 0;
}
