#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int MAXN = 1100000;
const i64 P = 1000000000 + 9;

i64 delta[2 * MAXN];

void add(i64 &x, i64 y) {
	x += y;
	x %= P;
	if (x < 0) x += P;
}

void solve() {
	int M, N;
	cin >> M >> N;
	if (N == 0) {
		cout << 1 << '\n';
		return;
	}
	delta[1] = 1;
	delta[M] = P-1;
	i64 sum = 0;
	for (int i = 1; i <= N; ++i) {
		add(sum, delta[i]);
		add(delta[i + 1], sum);
		add(delta[i + M + 1], -sum);
	}
	cout << sum << '\n';
	//return;
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}
