#include <bits/stdc++.h>

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

int len;

struct state {
    int p1, l1;
    int p2, l2;
    int mask;
    int has;

    state() {}
    state(int _p1, int _l1, int _p2, int _l2, int _p3, int _l3, int m) {
        len = min(_l1, min(_l2, _l3));
        assert(len > 0);
        _l1 -= len;
        _l2 -= len;
        _l3 -= len;
        if (_l1 < _l2) {
            swap(_l1, _l2);
            swap(_p1, _p2);
            m = (m & 1) | (((m >> 1) & 1) << 2) | (((m >> 2) & 1) << 1);
        }
        if (_l2 < _l3) {
            swap(_l2, _l3);
            swap(_p2, _p3);
            m = ((m & 1) << 2) | (m & 2) | ((m >> 2) & 1);
        }

        if (_l1 < _l2) {
            swap(_l1, _l2);
            swap(_p1, _p2);
            m = (m & 1) | (((m >> 1) & 1) << 2) | (((m >> 2) & 1) << 1);
        }
        if (!_l1) {
            _p1 = 30;
        }
        if (!_l2) {
            _p2 = 30;
        }
        p1 = _p1, l1 = _l1;
        p2 = _p2, l2 = _l2;
        mask = m;
        calcHas();
    }
    void calcHas() {
        has = 0;
        has = has * 31 + p1;
        has = has * 51 + l1;

        has = has * 31 + p2;
        has = has * 51 + l2;

        has = has * 8 + mask;
    }
    bool operator<(const state & r) const {
        return has < r.has;
    }
};

int dist[31*51*31*51*8];

int lcp[30][30][51];

void solve(){
    in(n);
    string s[n];
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int k = 1; k <= (int)s[i].length(); ++k) {
                lcp[i][j][k] = 0;
                for (int & res = lcp[i][j][k]; res < (int)s[j].length() && res < k; ++res) {
                    if (s[i][s[i].length() - k + res] != s[j][res]) {
                        break;
                    }
                }
            }
        }
    }

    set <pair <int, state> > q;
    memset(dist, 0x3f, sizeof(dist));
    state initial;

    initial.l1 = 0;
    initial.l2 = 0;
    initial.p1 = 30;
    initial.p2 = 30;
    initial.mask = 0;
    initial.calcHas();
    //cerr << initial.has << endl;
    //cerr << sizeof(dist) / 4 << endl;
    dist[initial.has] = 0;
    q.insert(mp(0, initial));

    while (!q.empty()) {
        state v = q.begin()->y;
        q.erase(q.begin());
        if (v.l1 == 0 && v.l2 == 0 && v.mask == 7) {
            cout << dist[v.has] << "\n";
            return;
        }
        if (v.l1 == 0) {
            for (int i = 0; i < n; ++i) {
                for (int j = i; j < n; ++j) {
                    for (int k = j; k < n; ++k) {
                        int mask = v.mask | ((i != j) << 0) | ((j != k) << 1) | ((i != k) << 2);
                        if (lcp[i][j][s[i].length()] != (int)min(s[i].length(), s[j].length())) {
                            continue;
                        }
                        if (lcp[i][k][s[i].length()] != (int)min(s[i].length(), s[k].length())) {
                            continue;
                        }
                        if (lcp[j][k][s[j].length()] != (int)min(s[j].length(), s[k].length())) {
                            continue;
                        }
                        state nstate(i, s[i].length(), j, s[j].length(), k, s[k].length(), mask);

                        if (dist[nstate.has] > dist[v.has] + len) {
                            q.erase(mp(dist[nstate.has], nstate));
                            dist[nstate.has] = dist[v.has] + len;
                            q.insert(mp(dist[nstate.has], nstate));
                        }
                    }
                }
            }
            continue;
        }
        if (v.l2 == 0) {
            for (int i = 0; i < n; ++i) {
                for (int j = i; j < n; ++j) {
                    //assert((v.mask & 1) && (v.mask & 4));
                    int mask = v.mask | ((i != j) << 1) | 1 | 4;
                    if (lcp[i][j][s[i].length()] != (int)min(s[i].length(), s[j].length())) {
                        continue;
                    }
                    if (lcp[v.p1][i][v.l1] != min((int)s[i].length(), v.l1)) {
                        continue;
                    }
                    if (lcp[v.p1][j][v.l1] != min((int)s[j].length(), v.l1)) {
                        continue;
                    }
                    state nstate(v.p1, v.l1, i, s[i].length(), j, s[j].length(), mask);
                    if (dist[nstate.has] > dist[v.has] + len) {
                        q.erase(mp(dist[nstate.has], nstate));
                        dist[nstate.has] = dist[v.has] + len;
                        q.insert(mp(dist[nstate.has], nstate));
                    }
                }
            }
            continue;
        }
        for (int i = 0; i < n; ++i) {
            //assert(v.mask == 7);
            int mask = v.mask | 2 | 4;
            if (lcp[v.p1][i][v.l1] != min((int)s[i].length(), v.l1)) {
                continue;
            }
            if (lcp[v.p2][i][v.l2] != min((int)s[i].length(), v.l2)) {
                continue;
            }
            state nstate(v.p1, v.l1, v.p2, v.l2, i, s[i].length(), mask);
            if (dist[nstate.has] > dist[v.has] + len) {
                q.erase(mp(dist[nstate.has], nstate));
                dist[nstate.has] = dist[v.has] + len;
                q.insert(mp(dist[nstate.has], nstate));
            }
        }
    }
    cout << "-1\n";
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    solve();

    return 0;
}
