#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const int N = (int) 1e6 + 10;
const int M = (int) 1e9 + 9;
int sum[N], f[N], n, m;

int get_sum(int r) {
	return (r < 0) ? 0 : sum[r];
}

int get_sum(int l, int r) {
	return (get_sum(r) - get_sum(l - 1) + M) % M;
}

int op(int m, int n) {
	if (n == 1) return 0;
	if (n % m == 0) return 1 + op(m, n / m);
	return op(m, n + 1) + 1;
}

int stupid(int m, int n) {
	int res = 0;
	for (int i = 1; i <= 100000; ++i)
		res += (int) (op(m, i) == n);
	return res;
}

int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d%d", &m, &n);
	f[0] = 1, sum[0] = 1;
	for (int i = 1; i <= n; ++i) {
		f[i] = get_sum(i - m, i - 1);
		if (i == m) f[i]--;
		sum[i] = (sum[i - 1] + f[i]) % M;
	}
	//assert(f[n] == stupid(m, n));
	printf("%d\n", f[n]);
	return 0;
}