#pragma comment(linker, "/STACK:256000000")

#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int maxn = 1000000 + 100;
const int maxm = 1000000 + 100;

const int mod = 1000000000 + 9;


int d[maxn];
int a[maxn];

int inline getSum(int l, int r)
{
	//if (l > r)
	//		return 0;
	
	if (r < 0)
		return 0;
	
	int res = a[r];
	if (l > 0)
	{
		res = ((res - a[l - 1]) % mod + mod) % mod;
	}
	return res;
}


int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	int N, M;
	scanf("%d%d", &M, &N);

	d[0] = 1;
	a[0] = 1;
	for (int n = 1; n <= N; ++n)
	{
		//d[n] = getSum(0, n - 1);
		d[n] = d[n - 1];
		/*if (M - n + 1 >= 1 && M - n + 1 < M)
		{
			d[n] += 1;
			d[n] %= mod;
		}*/
		d[n] += getSum(n - M, n  - 2);
		d[n] %= mod;
		
		a[n] = (a[n - 1] + d[n]) % mod;
	}

	printf("%d\n", d[N]);

	return 0;
}