#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <map>
#include <set>
#include <climits>
#include <cassert>
#include <cctype>
#include <queue>
#include <ctime>
#include <bitset>
using namespace std;

typedef long long ll;
typedef double dbl;
typedef long double ld;

#define mp make_pair
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(),x.end()
#define X first
#define Y second

const ll maxn = 200*1000 + 10;
const dbl eps = 1e-7;
const int mod = 1e9 + 9;


int main() {
#ifdef _MBCS
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
#define TES
	#ifdef TEST
	int n = 10;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cout << i*j / n << i*j % n << ' ';
		}
		puts("");
	}
	return 0;
	

#else
	ll n, m;
	scanf("%lld%lld", &m, &n);
	vector <ll> ans (n + 2);
	vector <ll> del (m + n + 2);
	ans[0] = ans[1] = 1;
	del[m] = 1;
	for (int i = 2; i <= n; i++) {
		ans[i] = (2LL*ans[i - 1] + mod - del[i]) % mod;
		del[i + m] = ans[i - 1];
	}
	printf("%lld", ans[n]);
	return 0;
#endif
}