#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000009;
#define mp make_pair

bool go(int m, int n, int curr, int todo=0){
	if(curr==1){
		return todo==0;
	}
	if(todo <= 0){
		return false;
	}
	if(curr%m){
		return go(m,n,curr+1,todo-1);
	}
	else{
		return go(m,n,curr/m,todo-1);
	}
}

long long solve(int m, int n){
	long long res=0;
	for(int i=1; i<=100000000; ++i){
		if(go(m,n,i,n)){
			res++;
		}
	}
	return res;
}


int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int m,n;
	cin>>m>>n;
	vector<long long>d(1000001);
	d[0]=1;
	d[1]=1;
	for(int i=2; i<=m-1; ++i){
		d[i]=d[i-1]*2;
		d[i]%=MOD;
	}
	d[m]=d[m-1]*2-1;
	d[m]%=MOD;
	long long sum=d[m-1]*4 - 2;
	sum%=MOD;
	for(int i=m+1; i<=n; ++i){
		d[i]=sum;
		sum-=d[i-m];
		sum+=d[i];
		while(sum<0)sum+=MOD;
		sum%=MOD;
	}

	//cout<<d[n]<<endl<<solve(m,n);
	cout<<d[n];
	return 0;
}