#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

const int N = 50;

const li MOD = 1234567891;

int n, m;
int c[N], a[N];
li r[N];

bool read() {
	if (scanf("%d %d", &n, &m) != 2)
		return false;
	forn(i, m)
		scanf("%d", &c[i]);
	return true;
}

li binpow(li a, li b, li m) {
	li cur = a, res = 1;
	for (int i = 0; (1LL << i) <= b; ++i) {
		if ((1LL << i) & b)
			res = (res * cur) % m;
		cur = (cur * cur) % m;
	}

	return res % m;
}

li calcc(li n, int k) {
	li en = 1;
	li den = 1;
	for (int i = 1; i <= k; ++i) {
		if (i) {
			en = (en * (n - i + 1)) % MOD;
			den = (den * i) % MOD;
		}
	}

	return (en * binpow(den, MOD - 2, MOD)) % MOD;
}

li calc(li n, int* a) {
	int sum = 0;
	forn(i, m)
		sum += a[i];

	if (sum > n)
		return false;

	li res = 1;

	forn(i, m) {
		res = (res * calcc(n, a[i])) % MOD;
		n -= a[i];
	}

	return res;
}

void solve() {
	forn(i, 3) {
		int v = (1 << i);
		int c1 = 0;

		bool good = true;

		forn(j, m) {
			int md = (c[j] & (v - 1));
			if (md > 1)
				good = false;
			if (md == 1)
				c1++;

			a[j] = c[j] - md;
		}

		if (c1 > 1)
			good = false;

		if (c1 == 1 && (n % 2) != 1)
			good = false;

		r[i] = 0;

		if (good) {
			li c = li(n) * n;
			c >>= i;

			r[i] = calc(c, a);
		}
	}

	r[1] = (r[1] - r[2] + MOD) % MOD;

	r[0] = (r[0] - 2 * r[1] - r[2] + MOD * 10) % MOD;
	r[0] = (r[0] * binpow(4, MOD - 2, MOD)) % MOD;

	cout << (r[0] + r[1] + r[2]) % MOD << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while(read())
		solve();

	return 0;
}