#include <iostream>
#include <climits>

using namespace std;
typedef long long int Z;

const Z M = 1000000009;

int S[1000005];

int main() { 
	int n, m;
	cin >> m >> n;
	
	if(n == 0) {
		cout << 1 << "\n";
		return 0;
	}
	if(n <= m) {
		Z ret = 1;
		for(Z i = 0; i < n - 1; ++i) {
			ret *= 2;
			ret %= M;
		}
		if(n == m) {
			ret += M - 1;
			ret %= M;
		}
		cout << ret << "\n";
		return 0;
	}
	
	Z val = 2;
	for(Z i = 1; i <= m; ++i) {
		S[i] = (S[i - 1] + val) % M;
		val *= 2;
		val %= M;
	}
	S[m] += M - 1;
	S[m] %= M;
	
	for(Z i = m + 1; i <= n; ++i) {
		S[i] = S[i - 1];
		S[i] += S[i - 1];
		S[i] %= M;
		S[i] += M - S[i - m - 1];
		S[i] %= M;
	}
	
/*	for(Z i = 1; i <= n; ++i) {
		cout << "g(" << i << ") = " << S[i] - S[i - 1] << "\n";
	}
*/	
	Z ret = S[n - 2];
	ret += M - S[n - m - 1];
	ret %= M;
	cout << ret << "\n";

 	return 0;
}
