#include <stdio.h>

using namespace std;

const int BASE = 1e9 + 9;
const int N = 55;
const int M = 2500;

int n, m, a[N], f[N][N][2 * M + 5];

void add(int &x, int y) {
	x += y;
	if (x >= BASE) x -= BASE;
}

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++) scanf("%d", &a[i]);
	f[0][0][0 + M] = 1;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= i; j++) {
			for (int s = -M; s <= M; s++) {
				if (f[i][j][s + M] == 0) continue;
			//i' == i
				add(f[i + 1][j][s + M], f[i][j][s + M]);
			// i' < i
				int jj = j;
				if (jj > 0) {
					int cur = (f[i][j][s + M] * 1LL * jj) % BASE;
					add(f[i + 1][j][s + M], cur);
					if ((j > 0) && (s + 2 * a[i] <= M)) add(f[i + 1][j - 1][s + 2 * a[i] + M], (cur * 1LL * j) % BASE);
				}
			// i' > i
				int cur = f[i][j][s + M];
				if (s - 2 * a[i] >= -M) add(f[i + 1][j + 1][s - 2 * a[i] + M], cur);
				add(f[i + 1][j][s + M], (cur * 1LL * j) % BASE);
			}
		}
	}
	printf("%d\n", f[n][0][2 * m + M]);
}