#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

using namespace std;

const int N = 1111111;
const int INF = 1e9;
const int BASE = 1e9 + 9;

int n, m, f[N], g[N], ans;

int main() {
	freopen("input.txt", "r", stdin);
	scanf("%d%d", &m, &n);
	if (n == 0) {
		printf("%d\n", 1);
		return 0;
	}
	f[0] = 1;
	g[1] = 1;
	for (int i = 1; i <= n; i++) {
		f[i] = (g[i] - g[max(0, i - m)] + BASE) % BASE;
		g[i + 1] = (g[i] + f[i]) % BASE;
	}
	for (int i = 1; i < m; i++) {
	//non-zero
		int cost = (m - i - 1 + 1);
		if (cost <= n) {
			int cur = (f[n - cost] - 1 + BASE) % BASE;
			ans = (ans + cur) % BASE;
		}
	//all-zero
		cost = i == 1 ? 0 : m - i + 1;
		if (cost <= n) {
			int cur = 1;
			ans = (ans + cur) % BASE;
		}
	}
	printf("%d\n", ans);
	return 0;
}
