#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <cstring>

using namespace std;

class Wardrobe {
public:
	static int countUnscrewedHoles(vector < int >);
};

int d[110][55][55][4];
int a[110];

int calc(int s, int n1, int n2, int flag)
{
    if (d[s][n1][n2][flag] != -1000000) return d[s][n1][n2][flag];

    d[s][n1][n2][flag] = -500000;
    if (s == 0) return d[s][n1][n2][flag];
    for (int p1 = 0; p1 <= 50; p1 ++)
    {
        if (p1 + n2 > a[s]) break;
        for (int p2 = 0; p2 <= 50; p2 ++)
        {
            if (p2 + n1 > a[s]) break;
            for (int f = 0; f < 3; f ++)
            {
                if (f + flag == 3) continue;
                if (flag == 0 && p1 + n2 == p2 + n1)
                    d[s][n1][n2][flag] = max(d[s][n1][n2][flag], calc(s - 1, p1, p2, f));
                if (flag == 1 && p1 + n2 >= p2 + n1)
                    d[s][n1][n2][flag] = max(d[s][n1][n2][flag], calc(s - 1, p1, p2, f) + (p1 + n2) - (p2 + n1));
                if (flag == 2 && p1 + n2 <= p2 + n1)
                    d[s][n1][n2][flag] = max(d[s][n1][n2][flag], calc(s - 1, p1, p2, f) - (p1 + n2) + (p2 + n1));
            }
        }
    }
    return d[s][n1][n2][flag];
}

int Wardrobe::countUnscrewedHoles(vector < int > bolts) {
    memset(a, 0, sizeof(a));
    for (int i = 0; i < 107; i ++)
        for (int j = 0; j <= 50; j ++)
            for (int k = 0; k <= 50; k ++)
                for (int l = 0; l < 3; l ++)
                    d[i][j][k][l] = -1000000;

    d[0][0][0][0] = 0;

    for (int i = 0; i < bolts.size(); i ++)
        a[bolts[i]] ++;

    return calc(105, 0, 0, 0) / 2;
}

int main() {
	int n;
	cin >> n;
	vector < int > a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	cout << Wardrobe::countUnscrewedHoles(a) << endl;

	return 0;
}