#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000009
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001
#define ll long long
#define ull unsigned long long
#define y yyy

using namespace std;
long long n, m;

bool check(long long c, ll m, ll n) {
    long long kol = 0;
    while (c != 1) {
        if (c % m != 0 || c == 0) {
            c++;
        } else {
            c /= m;
        }
        kol++;
    }
    if (kol == n) {
        return true;
    } else {
        return false;
    }
}

ll brut(ll m, ll n)
{
    long long ans = 0;

        long long maxn = pow(m, n);

        for (long long i = 1; i <= maxn; i++) {
            if (check(i, m, n)) {
                //cout << i << ", ";
                ans++;
            }
        }
        //cout << " = " << ans << endl;

    return ans;
}

ll binpow(ll x, ll y)
{
    ll ans = 1;
    while (y)
    {
        if (y & 1)
            ans *= x;
        x *= x;
        ans %= md;
        x %= md;
        y >>= 1;
    }
    return ans;
}

ll d[1000001];
ll task(ll m, ll n)
{
    if (n == m)
    {
        return binpow(2, n-1) - 1;
    }
    if (m > n)
    {
        return binpow(2, n-1);
    }
    d[0]=1; d[1] = 1;
    for (int i = 2; i < m; i++)
    {
        int j = 0;
        d[i] = 2 * d[i-1];
        d[i] %= md;
    }
    for (int i = m; i <= n; i++)
    {
        int j = i - m;
        if (i == m)
        {
            j++;
            d[i] = 2 * d[i-1] - d[j];
            d[i] += md;
            d[i] %= md;
            continue;
        }
        if (i == m + 1)
            d[i] = 2 * d[i-1];
        else d[i] = 2 * d[i-1] - d[j - 1];
        d[i] += md;
        d[i] %= md;
    }
    return d[n];
}



int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    int m, n;
    cin >> m >> n;
    if (n == 0)
    {
        cout << 1;
        return 0;
    }
    if (n == 1 || m == 1)
    {
        cout << 1;
        return 0;
    }
    cout << task(m, n);
    return 0;
    /*while (cin >> m >> n) {

        if (brut(m, n) == task(m, n))
            cout << "OK" << endl;
    //cout << brut(m, n) << endl;
    }*/
    //cout << d[n];
}
