#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e5+11;
const ll inf = (1ull<<63);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

ull dp[3][31][31][91][91];
bool used[3][31][31][91][91];

string c[31];
int pref[33][33];
int n;

void process(){
	for(int i = 0; i < n; i++){
		for(int j = i; j < n; ++j){
			int k = 0;                             
			while(k < c[j].size() && c[j][k] == c[i][k]) k++;
			pref[i][j] = (c[j].size() == k); 
		}
	}
}

bool ok(int i, int j, int k){
	return pref[i][j] && pref[j][k];
}

int cmp(string a, string b){
	if(a.size() > b.size()) return 1;
	if( a.size() < b.size()) return 0;
	return a > b;
}

ull get(int mask, int i, int j, int d1, int d2){
	if(d1 < 0 || d2 < 0 || d1 > 90 || d2 > 90) return inf;
	ull &res = dp[mask][i][j][d1][d2];
	if(used[mask][i][j][d1][d2]) return res;
	used[mask][i][j][d1][d2] = 1;
	res = inf;
	if( mask == 0){
		if( d1 == 0 && d2 == 0 ) return res = 0; 
		for(int x = 0; x < n; x++){
			int k = 0;
			int z = d2;
			while( k < c[x].size() && z > 0 && c[j][c[j].size() - z] == c[x][k]){
				k++;
				z--;
			}
			if( k == c[x].size() ){
				res = min(res, get(0, i, j, d1, d2 - k));
				continue;
			}
			if( z != 0) continue;
			z = d1;
			int k1 = k;
			while( k < c[x].size() && z > 0 && c[i][c[i].size() - z] == c[x][k]){
				k++;
				z--;
			}
			if( k == c[x].size()){
				res = min(res, get(0, i, x, z, k-k1));
				continue;
			}
			if( z!=0) continue;
			res = min(res, get(0, x, i, c[x].size()-k, d1) + (int)c[x].size() - k);
		}
	}
	else if( mask == 1){
		for(int x = 0; x<n; x++){
			int k = 0;
			int z = d1;
			while( k < c[x].size() && z > 0 && c[x][k] == c[i][c[i].size()-z]){
				k++;
				z--;
			}
			if( k == c[x].size()) {
				res = min(res, get(1, i, x, z, 0));
				for(int y = x+1; y < n; y++){
					if(!pref[x][y]) continue;
					res = min(res, get(0, i, x, z, (int)c[x].size() - (int)c[y].size()));
				}
				continue;
			}
			if(z!=0) continue;
			res = min(res, get(2, x, x, 0, c[x].size() - k) + (int)c[x].size() - k);
			for(int y = x+1; y < n; y++){
				if(!pref[x][y]) continue;
					if( k > c[y].size()) {
						res = min(res, get(0, x, i, (int)c[x].size() - k, k - c[y].size()) + (int)c[x].size() - k);
					}
					else
						res = min(res, get(0, x, y, c[x].size() - c[y].size(), c[y].size() - k) + (int)c[x].size() - k);
				}
		}
	}
	else {
		for(int x = 0; x < n; x++){
			int k = 0;
			int z = d2;
			while( k < c[x].size() && z > 0 && c[j][c[j].size() - z] == c[x][k]){
				k++;
				z--;
			}
			if(k == c[x].size()){
				res = min(res, get(2, i, j, 0, d2 - k));
				continue;
			}
			if( z != 0) continue;
			res = min(res, get(1, x, i, c[x].size() - k, 0) + (int)c[x].size()-k);
		}
	}
	return res;
}


int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	cin >> n;
	for(int i = 0; i < n; i++){
		cin >> c[i];
	}
	sort(c, c + n, cmp);

	//for(int i = 0; i < n; i++) cout << c[i] << endl;
	process();
	ull ans = inf;
	for(int i = 0; i < n; i++){
		for(int j = i+1; j < n; j++){
			for(int k = j+1; k < n; k++){
				if(ok(i, j, k) ) ans = min(ans, get(0, i, j, c[i].size() - c[j].size(), c[j].size() - c[k].size()) + (int)c[i].size());
			}
			if(ok(i, j, j)) ans = min(ans, get(1, i, j, c[i].size() - c[j].size(), 0) + (int)c[i].size());
			if(ok(i, i, j)) ans = min(ans, get(2, i, i, 0, c[i].size() - c[j].size()) + (int) c[i].size());
		}
	}
	if( ans >= inf) cout << -1 << endl;
	else cout << ans << endl;
	


	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
