#include <iostream>

using namespace std;

int hcube(int i, int m, int n, int dim) {
	if (dim == 0) return (i==n);
	int diff = i-n;
	if (diff < 0) return 0;
	if (diff >= m*dim) return 0;
	if (dim == 1) return (diff < m);

	long long result = 0;
	for (int j=0;j<m;++j) {
		result += hcube(i-j, m, n, dim-1);
		result %= 1000000009;
	}
	return result;
}

int main() {
	long long n,m;
	cin >> m >> n;
	int cur_dim = 0;
	long long result = 0;
	while (cur_dim < n) {
		for (int i=1; i<m; ++i) {
			result += hcube(m*(cur_dim+1)-i, m, n, cur_dim);
			result %= 1000000009;
		}
		++cur_dim;
	}
	cout << result << endl;
}

/*
int main()
{
	freopen("out.txt", "w", stdout);
	long long lll = 0;
	long long kkk = 0;
	long long n,m;
	cin >> m >> n;
	for (int i=1;i<=10000;++i){
	long long num = 0;
	n=i;
	while (n!=1)
	{
		if (n%m == 0)
		{
			n /= m;
			num++;
		}
		else 
		{	
			num = num + (n/m+1)*m - n;
			n = (n/m+1)*m;
		}
		num %= 1000000009;
	}
	if (0||(lll++ % (m) == 0)) {
	if (kkk++ % m == 0) cout << " ";
	if (i==1) num = m;
	//cout << i << " ";
	cout << (num) << " " << endl;
	}
	}
	return 0;
}*/