#include <iostream>
#include <cstdio>
using namespace std;

bool Good(int x, int m, int n)
{
    int cur = 0;
    while (x != 1) {
        if (x % m == 0) {
            x /= m;
        } else {
            ++x;
        }
        ++cur;
        if (cur > n) {
            return false;
        }
    }
    return cur == n;
}

const int modulo = 1e9 + 9;

const int max_n = 1e6 + 10;

int ans[max_n];

int main()
{
    /*
    freopen("output.txt", "w", stdout);
    for (int m = 2; m <= 7; ++m) {
        cout << "m = " << m << endl;
    for (int n = 0; n <= 7; ++n) {
        cout << "  n = " << n << ": ";
        int ans = 0;
        int max_i = 1;
        for (int i = 0; i < n; ++i) {
            max_i *= m;
        }
        for (int i = 1; i <= max_i; ++i) {
            if (Good(i, m, n)) {
                ++ans;
            }
        }
        cout << ans << endl;
    }

    }
*/
    int n, m;
    cin >> m >> n;

    ans[0] = 1;
    ans[1] = 1;

    for (int i = 2; i <= m; ++i) {
        ans[i] = (2LL * ans[i - 1]) % modulo;
    }

    --ans[m];
    if (ans[m] < 0) {
        ans[m] += modulo;
    }

    int sum = 0;
    for (int i = 1; i <= m; ++i) {
        sum = sum + ans[i];
        if (sum >= modulo) {
            sum -= modulo;
        }
    }

    for (int i = m + 1; i <= n; ++i) {
        ans[i] = sum;
        sum += ans[i];
        if (sum >= modulo) {
            sum -= modulo;
        }
        sum -= ans[i - m];
        if (sum < 0) {
            sum += modulo;
        }
    }

    cout << ans[n] << endl;

    return 0;
}
