#include <iostream>

using namespace std;

long long a[55], fact[111111];

const int base = 1234567891;

long long n, m;

long long powmod(long long a, int b)
{
	long long res = 1;
	while (b > 0)
	{
		if (b & 1)
		{
			res = (res * a) % base;
		}
		b >>= 1;
		a = (a * a) % base;
	}
	return res;
}

long long get(long long n, int cnt)
{
	long long ans = 1;
	for(long long i = n; i > n - cnt; i--)
	{
		ans = (ans * (i % base)) % base;
	}
	return ans;
}

int main()
{
	fact[0] = 1;
	for(int i = 1; i < 111111; i++)
	{
		fact[i] = (fact[i - 1] * i) % base;
	}
	
	cin >> n >> m;
	long long cnt = 0;
	for(int i = 0; i < m; i++)
	{
		cin >> a[i];
		cnt += a[i];
	}
	if (cnt > n * n)
	{
		cout << 0 << endl;
		return 0;
	}
	a[m] = n * n - cnt;
	
	long long ans = get(n * n, cnt);
	for(int i = 0; i < m; i++)
	{
		//cout << ans << endl;
		ans = (ans * powmod(fact[a[i]], base - 2)) % base;
	}
	//cout << ans << endl;
	
	long long a4 = 0;
	if (n & 1)
	{
		int ii = -1;
		int cnt = 0;
		for(int i = 0; i <= m; i++)
		{
			if (a[i] % 4 == 1)
			{
				if (ii != -1)
				{
					ii = -2;
					break;
				} else {
					ii = i;
				}
			} else if (a[i] % 4 > 1)
			{
				ii = -2;
				break;
			}
			if (i < m) 
			cnt += a[i] / 4;
		}
		if (ii >= 0)
		{
			a4 = get(n * n / 4, cnt);
			for(int i = 0; i < m; i++)
			{
				a4 = (a4 * powmod(fact[a[i] / 4], base - 2)) % base;
			}
		}
	} else {
		int ii = 1;
		int cnt = 0;
		for(int i = 0; i <= m; i++)
		{
			if (a[i] % 4 >= 1)
			{
				ii = -1;
				break;
			}
			if (i < m)
			cnt += a[i] / 4;
		}
		if (ii >= 0)
		{
			a4 = get(n * n / 4, cnt);
			for(int i = 0; i < m; i++)
			{
				a4 = (a4 * powmod(fact[a[i] / 4], base - 2)) % base;
			}
		}
	}
	
	long long a2 = 0;
	
	if (n & 1)
	{
		int ii = -1;
		int cnt = 0;
		for(int i = 0; i <= m; i++)
		{
			if (a[i] % 2 == 1)
			{
				if (ii != -1)
				{
					ii = -2;
					break;
				} else {
					ii = i;
				}
			}
			if (i < m)
			cnt += a[i] / 2;
		}
		if (ii >= 0)
		{
			a2 = get(n * n / 2, cnt);
			for(int i = 0; i < m; i++)
			{
				a2 = (a2 * powmod(fact[a[i] / 2], base - 2)) % base;
			}
		}
	} else {
		int ii = 1;
		int cnt = 0;
		for(int i = 0; i <= m; i++)
		{
			if (a[i] % 2 == 1)
			{
				ii = -1;
				break;
			}
			if (i < m)
			cnt += a[i] / 2;
		}
		if (ii >= 0)
		{
			a2 = get(n * n / 2, cnt);
			for(int i = 0; i < m; i++)
			{
				a2 = (a2 * powmod(fact[a[i] / 2], base - 2)) % base;
			}
		}
	}
	//ut << ans << " " << a2 << " " << a4 << endl;
	long long ans0 = (ans - (a2 - a4) - a4 + (long long)base * 4) * powmod(4, base - 2) + a2;
	cout << (ans0 + base)% base << endl;
	
}