#include <iostream>
#include <cstdio>

using namespace std;

#define MAXN 1000100
#define MOD 1000000007
#define lint long long

lint dinam[MAXN];
lint csum[MAXN];

lint getsum(int l, int r) {
	l = max(0, l);
	if (l > r) return 0;
	if (l == 0) return csum[r];
	return (csum[r] - csum[l - 1] + MOD) % MOD;
}

int main() {
	ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int m, n;
	cin >> m >> n;
	dinam[0] = 1;
	csum[0] = 1;
	m--;
	for (int i = 1; i <= n; i++) {
		dinam[i] = getsum(i - m, i - 1);
		csum[i] = (csum[i - 1] + dinam[i]) % MOD;
	}
	cout << dinam[n];
	return 0;
}