#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <memory.h>
#include <unordered_map>

#define forn(i, n) for(int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i) 
#define for1(i, n) for(int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for(int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;

const int MAXN = 1100000;
const i64 P = 1000000000 + 9;

struct TState {
	int a, s;

	TState(int a = 0, int s = 0)
		: a(a)
		, s(s)
	{
	}

	bool operator<(const TState &st) const {
		if (a != st.a) return a < st.a;
		return s < st.s;
	}
};

//map<TState, i64> dp[51];
i64 dp[51][51][3000];
const int OFF = 1500;
int t[51];

void add(i64 &x, i64 y) {
	x += y; x %= P;
	if (x < 0) x += P;
}

i64 get_dp(int N, TState st) {
	if (N == 0) {
		if (st.a == 0 && st.s == 0) return 1;
		return 0;
	}
	//if (dp[N].count(st)) return dp[N][st];
	int a = st.a, s = st.s;
	i64 &res = dp[N][a][s + OFF];
	if (res != -1) return res;
	res = 0;
	if (a) add(res, a * a * get_dp(N - 1, TState(a - 1, s + t[N - 1])));
	add(res, (2 * a + 1) * get_dp(N - 1, TState(a, s)));
	add(res, get_dp(N - 1, TState(a + 1, s - t[N - 1])));
	return res;
}

void solve() {
	forn(i, 51) forn(j, 51) forn(k, 3000) dp[i][j][k] = -1;
	int N, M;
	cin >> N >> M;
	forn(i, N) cin >> t[i];
	forn(i, N) t[i] = i;
	cout << get_dp(N, TState(0, M)) << '\n';
	//return;
}

int main() {
	cin.sync_with_stdio();
	cin.tie(0);
	cout.precision(12);
	cout << fixed;
	cerr.precision(12);
	cerr << fixed;
#ifdef HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}
