#include <iostream>
#include <cmath>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;

const int N = 2000010;
const ll M = 1000000009;
int n, m;
ll e[N];
ll cleft, cright;

int main()
{
	ios_base::sync_with_stdio(false);
	cin >>m >>n;

	cleft = 0, cright = 1;
	ll cpl = 0;
	for(int i = 0; i < n - 1; i++) {
		cpl += e[i];
		cpl %= M;
		ll curleft = cpl, curright = cright;
		e[i + 1] += curright;
		e[i + 1] %= M;
		e[i + m] += (M - curright);
		e[i + m] %= M;
		e[i + m] += M;
		e[i + m] %= M;
		cright = (curright + curleft) % M;
	}
	cpl += e[n - 1];
	cpl %= M;
	cleft = cpl;

	cout <<(cleft + cright) % M <<endl;
	return 0;
}