#include <iostream>
#include <cmath>
#include <bitset>
#include <cstdio>
#include <vector>
#include <string>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const int N = 2000010;
const ll M = 1000000009;
int n, m;
ll e[N];
ll cleft, cright;

inline ll cnt(ll m, ll n){
	set<ll> cur, tmp;
	cur.insert(1);
	for (int lvl = 0; lvl < n; ++lvl){
		tmp.clear();
		for (auto it = cur.begin(); it != cur.end(); ++it){
			ll x = *it;
			tmp.insert(x * m);
			--x;
			if (x % m != 0)
				tmp.insert(x);
		}
		swap(tmp, cur);
	}
	return cur.size();
}

int main()
{
	ios_base::sync_with_stdio(false);

	cin >>m >>n;
	if(n == 0) {
		cout <<1 <<endl;
		return 0;
	}
	//cout << cnt(m, n) << endl;

	cleft = 0, cright = 1;
	ll cpl = 0;
	for(int i = 0; i < n - 1; i++) {
		cpl += e[i];
		cpl %= M;
		ll curleft = cpl, curright = cright;
		e[i + 1] += curright;
		e[i + 1] %= M;
		e[i + m] += (M - curright);
		e[i + m] %= M;
		e[i + m] += M;
		e[i + m] %= M;
		cright = (curright + curleft) % M;
	}
	cpl += e[n - 1];
	cpl %= M;
	cleft = cpl;

	cout <<(cleft + cright) % M <<endl;
	return 0;
}