#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int M = 50;
const int K = 100000;

const ll mod = 1234567891;

struct Input {
	ll n, m;
	ll a[M];
	
	bool read () {
		if (!(cin >> n >> m)) {
			return 0;
		}
		forn (i, m) {
			int x;
			scanf("%d", &x);
			a[i] = x;
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	ll ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	
	ll pw (ll a, ll n) {
		ll ans = 1;
		while (n) {
			if (n & 1) {
				(ans *= a) %= mod;
			}
			(a *= a) %= mod;
			n >>= 1;
		}
		return ans;
	}
	
	ll f[K + 1], rf[K + 1], bf1[M * K + 1], bf2[M * K + 1], bf4[M * K + 1];
	
	void solve () {
		f[0] = 1;
		forn (i, K) {
			f[i + 1] = f[i] * (i + 1) % mod;
		}
		forn (i, K + 1) {
			rf[i] = pw(f[i], mod - 2);
		}
		bf1[0] = 1;
		forn (i, M * K) {
			bf1[i + 1] = bf1[i] * (ll(n) * ll(n) % mod - i + mod) % mod;
		}
		bf2[0] = 1;
		forn (i, M * K) {
			bf2[i + 1] = bf2[i] * (ll(n) * ll(n) / 2 % mod - i + mod) % mod;
		}
		bf4[0] = 1;
		forn (i, M * K) {
			bf4[i + 1] = bf4[i] * (ll(n) * ll(n) / 4 % mod - i + mod) % mod;
		}
		
		ans = 0;
		{
			int s = 0;
			forn (i, m) {
				s += a[i];
			}
			ll cur = bf1[s];
			forn (i, m) {
				(cur *= rf[a[i]]) %= mod;
			}
			debug(cur);
			(ans += cur) %= mod;
		}
		{
			int cnt = 0;
			int s = 0;
			forn (i, m) {
				cnt += a[i] % 2;
				s += a[i] / 2;
			}
			if (cnt <= ll(n) * ll(n) % 2) {
				ll cur = bf2[s];
				forn (i, m) {
					(cur *= rf[a[i] / 2]) %= mod;
				}
				debug(cur);
				(ans += cur) %= mod;
			}
		}
		{
			int cnt = 0;
			int s = 0;
			forn (i, m) {
				cnt += a[i] % 4;
				s += a[i] / 4;
			}
			if (cnt <= ll(n) * ll(n) % 4) {
				ll cur = bf4[s];
				forn (i, m) {
					(cur *= rf[a[i] / 4]) %= mod;
				}
				debug(cur);
				(ans += 2 * cur) %= mod;
			}
		}
		(ans *= pw(4, mod - 2)) %= mod;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
