#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 60;

struct Input {
	int n;
	int a[N];
	
	bool read () {
		if (scanf ("%d", &n) != 1)
			return 0;
		forn(i, n) {
			cin >> a[i];
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

const int inf = 1000000000;

struct Solution: Data {

	int d[N][N][N];
	vector <pair<int, int> > t;
	
	void solve () {
		ans = inf;
		sort(a, a + n);
		forn(i, N)
			forn(j, N)
				forn(k, N)
					d[i][j][k] = inf;
		for (int i = 0; i < n;) {
  	  		int j = i;
  	  		for (; j < n && a[i] == a[j]; ++j);
  			if (!t.empty()) {
  				int k = t.back().fs;
  				for (int z = k + 1; z < a[i]; ++z) {
  					t.pb(mp(z, 0));
  				}
  			}
  	  		t.pb(mp(a[i], j - i));
  	  		if (j == n) {
  	  			t.pb(mp(a[n - 1] + 1, 0));
  	  		}
  	  		i = j;
  	  	}
  	  	debug(t);
		d[0][0][t[0].sc] = 0;
		int oldn = n;
		n = t.size();
		for (int i = 0; i < n - 1; ++i) {
			forn(j, n + 1) {
				forn(k, n + 1) {
					if (d[i][j][k] >= inf)
						continue;
					if (t[i].sc > k + t[i + 1].sc) {
						umn(d[i + 1][0][0], d[i][j][k] + min(j + k + t[i + 1].sc, t[i].sc));
						continue;
					}
					for (int z = 0; z <= k; ++z) {
  						int help = t[i].sc - z;
  						if (help > t[i + 1].sc || help < 0)
  							continue;
  						//debug(mp(help, z));
  						//debug(mp(k, t[i].sc));
  						umn(d[i + 1][k - z][t[i + 1].sc - help], d[i][j][k] + t[i].sc); 
  					}			 	
				}
			}	
		}
		forn(i, N)
			forn(j, N) {
				umn(ans, d[n - 1][i][j]);
			}
		ans = oldn - ans;
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
//	freopen("", "r", stdin);
//	freopen("", "w", stdout);
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
