#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

const int M = 1234567891;
const int N = (int) 1e5 + 10;
int n, m, sum, a[N], fact[N], ifact[N], div2, div4, cnt2, cnt4;

int pow(int a, int b) {
	if (b == 0) return 1;
	if (b & 1) return (pow(a, b - 1) * (int64) a) % M;
	int tmp = pow(a, b / 2);
	return (tmp * (int64) tmp) % M;
}

int inverse(int x) {
	return pow(x, M - 2);
}

int A(int64 n, int k) {
	int res = 1;
	for (int i = 0; i < k; ++i)
		res = (res * (int64) (n % M + M - i)) % M;
	return res;
}
	
int main() {
	//assert(freopen("input.txt", "r", stdin));
	//assert(freopen("output.txt", "w", stdout));
	scanf("%d%d", &n, &m);
	fact[0] = ifact[0] = 1;
	for (int i = 1; i < N; ++i) {
		fact[i] = (fact[i - 1] * (int64) i) % M;
		ifact[i] = inverse(fact[i]);
	}
	for (int i = 0; i < m; ++i) {
		scanf("%d", &a[i]), sum += a[i];
		if (a[i] % 4 != 0) div4 = i, cnt4++;
		if (a[i] % 2 != 0) div2 = i, cnt2++;
	}
	int64 sq = n * (int64) n;
	if (sum > sq) {
		printf("0\n");
		return 0;
	}
	if (n % 2 == 0) {
		int res = A(sq, sum);
		for (int i = 0; i < m; ++i)
			res = (res * (int64) ifact[a[i]]) % M;
		if (cnt4 == 0) {
			int tmp = A(sq / 4, sum / 4);
			for (int i = 0; i < m; ++i)
				tmp = (tmp * (int64) ifact[a[i] / 4]) % M;
			res = (res + 2LL * tmp) % M;
		}
		if (cnt2 == 0) {
			int tmp = A(sq / 2, sum / 2);
			for (int i = 0; i < m; ++i)
				tmp = (tmp * (int64) ifact[a[i] / 2]) % M;
			res = (res + (int64) tmp) % M;
		}
		printf("%lld\n", (res * (int64) inverse(4)) % M);
	} else {
		int res = A(sq, sum);
		for (int i = 0; i < m; ++i)
			res = (res * (int64) ifact[a[i]]) % M;
		if ((cnt4 == 0) || ((cnt4 == 1) && (a[div4] % 4 == 1))) {
			int tmp = A(sq / 4, sum / 4);
			for (int i = 0; i < m; ++i)
				tmp = (tmp * (int64) ifact[a[i] / 4]) % M;
			res = (res + 2LL * tmp) % M;
		}
		if (cnt2 <= 1) {
			int tmp = A(sq / 2, sum / 2);
			for (int i = 0; i < m; ++i)
				tmp = (tmp * (int64) ifact[a[i] / 2]) % M;
			res = (res + (int64) tmp) % M;
		}
		printf("%lld\n", (res * (int64) inverse(4)) % M);
	}
	return 0;
}