#pragma comment(linker, "/STACK:256000000")

#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int inf = 1e9;

bool used[100][2][2][2][2]; 
int mas[100][2][2][2][2]; 
int n; 
int a[100]; 

int f(int i, bool isprev, bool iscur, bool needprev, bool needcur) {
	if (i == n) {

		if (iscur || needprev || needcur)
			return inf;

		return !((needprev && !isprev) || (needcur && !iscur)) ? 0 : inf; 
	}

	if (used[i][isprev][iscur][needprev][needcur]) return mas[i][isprev][iscur][needprev][needcur];
	used[i][isprev][iscur][needprev][needcur] = 1; 
	int & res = mas[i][isprev][iscur][needprev][needcur]; 
	res = inf; 
	if (needprev && !isprev) {
		if (a[i + 1] - a[i] > 1) {
			if (needcur && !iscur) return res = inf; 
			return res = 1 + f(i + 1, 1, 0, 0, 0); 
		} if (a[i + 1] == a[i] + 1) {
			return res = 1 + f(i + 1, iscur, 0, needcur, 0); 
		} else {
			return res = 1 + f(i + 1, isprev, iscur, 0, needcur); 
		}
	} 

	if (needcur && !iscur) {
		if (a[i + 1] - a[i] > 1) {
			updMin(res, 1 + f(i + 1, 0, 0, 0, 0)); 
		} if (a[i + 1] == a[i] + 1) {
			updMin(res, 1 + f(i + 1, 1, 0, 0, 0)); 
		} else {
			updMin(res, 1 + f(i + 1, isprev, 1, needprev, 0)); 
		}
	}

	if (a[i + 1] <= a[i] + 1 && isprev) {
		updMin(res, f(i + 1, iscur, 0,  !iscur, 1)); 
		//updMin(res, f(i + 1, iscur, 0, !iscur, 1)); 
	} 
	
	//if (a[i + 1] - a[i] > 1 && !(needcur && !iscur)) { 
	//	updMin(res, 1 + f(i + 1, a[i + 1] - a[i] == 2, 0, 0, 0)); 
	//} if (a[i + 1] == a[i] + 1) {
	//	if (!iscur)
	//		updMin(res, 1 + f(i + 1, 1, 0, 0, 0));
	//	updMin(res, 1 + f(i + 1, iscur, 1, needcur | (!iscur), 0));
	//} else {
	//	if (isprev && iscur) {
	//		updMin(res, f(i + 1, isprev, iscur, needprev, needcur)); 
	//	}
	//	if (!isprev) 
	//		updMin(res, 1 + f(i + 1, 1, iscur, 0, needcur));
	//	if (!iscur)
	//		updMin(res, 1 + f(i + 1, isprev, 1, needprev, 0));
	//}

	if (a[i + 1] - a[i] > 1) {
		if (!isprev && !needcur) 
			updMin(res, 1 + f(i + 1, 1, 0, 0, 0));
		if (!iscur && !needprev)
			updMin(res, 1 + f(i + 1, 1, 0, 0, 0)); 
	} else {
		if (!isprev && a[i] - a[i - 1] <= 1) {
			updMin(res, 1 + f(i + 1, iscur, 0, needcur, 0)); 
		}
		if (!needprev) {
			updMin(res, 1 + f(i + 1, 1, 0, 0, 0)); 
		}
		if (!needprev) {
			if (i == 0)
			{
				int stop = 1;
				++stop;
			}
			updMin(res, 1 + f(i + 1, iscur, 1, needcur, 0)); 
		}

	}

	return res; 

}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 

	//int x = 1234567891; 
	//for (int i = 2; i * i <= x; i++) {
	//	if (x % i == 0) {
	//		cout << "WA\n"; 
	//		break; 
	//	}
	//}
	//return 0; 

	cin >> n; 
	for (int i = 0; i < n; i++) {
		cin >> a[i]; 
	}

	sort(a, a + n);
	//a[n] = a[n - 1]; 
	a[n] = inf;

	cout << n - f(0, 1, 0, 0, 0) << "\n"; 

	return 0;
}