#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = 1000 * 1000 * 1000 + 9;


const int N = 1000500;
int F[N];
int SF[N];

int main() {
#ifdef LOCAL42
#define TASK "F"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int m, n;
	scanf("%d %d", &m, &n);
	F[0] = 1;
	SF[0] = 0;
	SF[1] = 1;
	for (int i = 1; i <= n; i++)
	{
		int l = max(0, i - m);
		int r = i;
		F[i] = SF[r] - SF[l];
		if (F[i] < 0)
			F[i] += MOD;
		SF[i + 1] = SF[i] + F[i];
		if (SF[i + 1] >= MOD)
			SF[i + 1] -= MOD;
	}

	int ans = F[n];
	if (n - m >= 0)
		ans = (ans - F[n - m] + MOD) % MOD;
	printf("%d\n", ans);
	return 0;
}
