#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

const LL MOD = 1000000009;

const int MAXN = 1048576;
LL dp[MAXN];
LL sum[MAXN];
LL calc(int n, int m) {
  if (n < 0) return 0;
  dp[0] = 1;
  sum[0] = 1;
  FOR(s, 1, n + 1) {
    LL l = max(0, s - m);
    LL r = s - 1;
    dp[s] = sum[r];
    if (l) dp[s] = (dp[s] - sum[l - 1] + MOD) % MOD;
    sum[s] = (sum[s - 1] + dp[s]) % MOD;
  }
  return dp[n];
}

int main() {
  int m, n;
  cin >> m >> n;
  cout << (calc(n, m) - calc(n - m, m) + MOD) % MOD;
  return 0;
}
