#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <algorithm>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <functional>
#include <climits>
#include <stack>
#include <cassert>

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ABS(a) (((a) > 0) ? (a) : (-(a)))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))
#define X first
#define Y second

using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> ii;
typedef pair<int, pair<int, int> > iii;
typedef pair<ll, ll> pl;

const int MAX_N = 1000050;
const int MOD = 1000000009;

ll dp[MAX_N];
ll ze[MAX_N];

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

	ll m; 
	ll n;
	cin >> m >> n;

	ZERO(dp);
	ZERO(ze);

	if (n == 0)
	{
		cout << "1";
		return 0;
	}

	dp[0] = 1;
	ze[m-1] = 1;

	for (int i = 1; i < n; ++i)
	{
		dp[i] = ((dp[i - 1] * 2) % MOD + MOD - ze[i]) % MOD;
		if (i + m < MAX_N)
		{
			ze[i + m] = (ze[i + m] + dp[i - 1]) % MOD;
		}
	}

	cout << dp[n-1];

    return 0;
}