#include <iostream>
#include <cassert>
#include <vector>
#include <cstring>
#include <cstdio>
using namespace std;

typedef long long ll;
typedef vector<int> vi;

ll mod = 1000000009;

int mem[1000][1000];

int m;
ll dp(int n, int last) {
    if (n == 0) {
        return 1;
    }

    if (mem[n][last] != -1) {
        return mem[n][last];
    }

    int res = 0;
    res += dp(n - 1, 0);
    res %= mod;
    if (last != 1) {
        res += dp(n - 1, last == 0 ? m - 1 : last - 1);
        res %= mod;
    }

    return mem[n][last] = res;
}

ll dp2(int n) {
    if (n < 0) {
        return 0;
    }
    if (n == 0) {
        return 1;
    }

    int res = 0;
    for (int i = 1; i <= m; i++) {
        res += dp2(n - i);
    }

    return res;
}

int main() {
    memset(mem, -1, sizeof(mem));

    int n;
    cin >> m >> n;

    int res;
    if (n == 0) {
        res = 1;
    } else {
        //cout << dp(n, 1) << endl;

        int *dp3 = new int[n+1];
        dp3[0] = 1;
        int sum = 1;
        for (int i = 1; i <= n; i++) {
            dp3[i] = sum;
            /*
            for (int i = 1; i <= m; i++) {
                res += dp2(n - i);
            }
            */

            sum += dp3[i];
            sum %= mod;
            if (i - m >= 0) {
                sum += mod - dp3[i-m];
                sum %= mod;
            }
        }

        res = 0;
        for (int i = 0; i < m; i++) {
            //res += dp2(n - i - 1);
            if (n-i-1 >= 0) {
                res += dp3[n-i-1];
                res %= mod;
            }
        }
    }

    cout << res << endl;
    //cout << dp(n, 1) << endl;

    return 0;
}
