#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int n;
const int N = 105;
int a[N];
int st[N];
int cnt[N];

bool read() {
	/*n = 50;
	forn (i, n)
		a[i] = rand() % 5 + 1;
	return true;*/

	if (!(cin >> n))
		return false;
	forn (i, n)
		cin >> a[i];

	return true;
}

int ans = 0;
int cur = 0;

int dp[N];
int it = 10000;
int rec(int pos)
{
	if (--it == 0)
	{
		it = 10000;
		if (clock() * 1000 / CLOCKS_PER_SEC > 980)
		{
			cout << ans << endl;
			cerr << clock() << endl;
			exit(0);
		}
	}
	if (pos == n)
	{
		ans = max(ans, cur);
		return 0;
	}
	if (dp[pos] < INF)
	{
		if (cnt[a[pos]] == st[a[pos]] && cnt[a[pos] + 1] == st[a[pos] + 1] && cnt[a[pos] - 1] == 0)
		{
			ans = max(ans, cur + dp[pos]);
			return dp[pos];
		}
	}

	bool any = true;
	int bt = 0;
	for (int i = a[pos] + 1; i >= a[pos] - 1; --i)
	{
		if (cnt[i])
		{
			any = false;
			cnt[i]--;
			bt = max(bt, rec(pos + 1));
			cnt[i]++;
		}
	}

	if (any)
	{
		cur++;
		bt = max(bt, rec(pos + 1));
		cur--;
	}

	if (dp[pos] == INF)
		if (cnt[a[pos]] == st[a[pos]] && cnt[a[pos] + 1] == st[a[pos] + 1] && cnt[a[pos] - 1] == 0)
			dp[pos] = any + bt;
	
	return any + bt;
}

void solve() {
	ans = 0;
	forn (i, N)
		cnt[i] = 0, st[i] = 0;
	sort(a, a + n);
	forn (i, n)
		cnt[a[i]]++, st[a[i]]++;
	forn (i, N)
		dp[i] = INF;
	rec(0);
	cout << ans << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	assert(read());
	solve();

	cerr << clock() << endl;

	return 0;
}